package jp.co.sds_corp.fxchart.graph;

import java.awt.Font;
import java.io.OutputStream;

import jp.co.sds_corp.nanchart.graph.XScale;
import jp.co.sds_corp.util.common.CmnDate;

/**
* 週足グラフを生成します。
*/
public class RateGraphWeek extends RateGraphDay
{
	protected void makeGraph( OutputStream out ) throws Exception {
		CmnDate to = getTo();
		if ( to == null ) {
			to = new CmnDate();
			setTo( to );
		}
		CmnDate fr = getFrom();
		if ( fr == null ) {
			fr = (CmnDate )to.clone();
			fr.add( CmnDate.DATE, -700 );
			setFrom( fr );
		}
		super.makeGraph( out );
	}

	protected CmnDate getMaDate( CmnDate dt ) {
		CmnDate ret = (CmnDate )dt.clone();
		ret.add( CmnDate.DATE, 0 - Integer.valueOf( ma ).intValue() * 7 );
		return ret;
	}

	protected void setXScale( XScale xs, String span, CmnDate fr, CmnDate to ) {
		Font font = new Font( "Dialog", Font.PLAIN, 8 );
		CmnDate tmp = (CmnDate )fr.clone();
		for ( ;; ) {
			tmp.add( CmnDate.DATE, 1 );
			if ( tmp.after( to ) ) {
				break;
			}
			if ( tmp.get( CmnDate.DATE ) == 1 ) {
				if ( tmp.get( CmnDate.MONTH ) == 0 ) {
					xs.add( tmp.clone(), tmp.format( "yyyy" ));
				} else {
					xs.add( tmp.clone(), "" );
				}
			}
		}
		xs.setLineStroke( getLineStroke() );
		xs.setLineColor( getLineColor() );
		xs.setScaleLine( true );
		xs.setFont( font );
	}

}
